//template <class Key> set 

#include <iostream>
#include <set>
#include <algorithm>
using namespace std;

int main (int argc, char *argv[]) {
  
  // container associativo - valor das chaves (Key)
  // acesso aos elementos e dado basicamente pelas chaves (conteudo)
  // implementado usando uma arvore binaria de busca
  set<int> conjunto;
  set<int>::iterator it;
  
  // versao 1 - insere um elemento simples
  // insere um elemento em tempo log(n)
  for (int i=1; i<=5; i++) {
      conjunto.insert(i*10);   // 10 20 30 40 50    
  }
  
  it = conjunto.begin(); // aponta para o elemento 10
  it++; // aponta para o elemento 20
  
  // versao 2 - insere um elemento de forma otimizada
  conjunto.insert(it, 25);  // insercao em tempo constante
  conjunto.insert(it, 23);  // insercao em tempo constante
  conjunto.insert(it, 26);  // insercao nao eh em tempo constante
  
  pair< set<int>::iterator , bool> ret;
  // ret.first; - iterator do tipo conjunto de inteiros
  // ret.second; - boolean
  
  ret = conjunto.insert(26);
  // a variavel ret vai conter 
  // - no primeio elemento a posicao do valor inserido
  // - no segundo elemento = true se o elemento e novo e = false se ja existia no conjunto
  if (ret.second == false) {
     cout << "elemento " << (*ret.first) << " ja foi inserido" << endl;
  }
  
  int A[4] = {5, 15, 40, 55};
  // versao 3 - insere um intervalo de elementos
  // [inicial,final)
  conjunto.insert(A, A+4);
  
  cout << "conteudo de set: " << endl;
  for (it = conjunto.begin(); it != conjunto.end(); it++) {
     cout << (*it) << " "; 
  }
  cout << endl;
  
  // versao 1 - deleta o elemento pela chave
  conjunto.erase(21);
  
  it = conjunto.find(10);
  // versao 2 - deleta o elemento pela posicao
  conjunto.erase(it);
  
  cout << "conteudo de set apos remocao	: " << endl;
  for (it = conjunto.begin(); it != conjunto.end(); it++) {
     cout << (*it) << " "; 
  }
  cout << endl;
  
  set<int> conjunto2;  
  conjunto2.insert(20);
  conjunto2.insert(10);
  conjunto2.insert(1); 
  conjunto2.insert(5); 
  
  cout << "conteudo de conjunto 2: " << endl;
  for (it = conjunto2.begin(); it != conjunto2.end(); it++) {
     cout << (*it) << " "; 
  }
  cout << endl;
  
  set<int> conjunto_int;  
  // executa interseccao
  // passo por parametro inicio e fim de cada conjunto a fazer interseccao
  // e um iterador para o conjunto a armazenar o resultado
  // -- inserter eh um construtor para um iterador capaz de
  //    realizar insercoes
  set_intersection(conjunto.begin(), conjunto.end(),
		   conjunto2.begin(), conjunto2.find(10),
		   inserter(conjunto_int, conjunto_int.begin()));
  
  cout << "interseccao: " << endl;
  for (it = conjunto_int.begin(); it != conjunto_int.end(); it++) {
     cout << (*it) << " "; 
  }
  cout << endl;
  
  conjunto_int.clear();
  // executa uniao, usa mesmos parametros da interseccao
  set_union(conjunto.begin(), conjunto.end(),
	    conjunto2.begin(), conjunto2.end(),
	    inserter(conjunto_int, conjunto_int.begin()));
  
  cout << "uniao: " << endl;
  for (it = conjunto_int.begin(); it != conjunto_int.end(); it++) {
     cout << (*it) << " "; 
  }
  cout << endl;
  
  return 0;   
}
